package com.dfrobot.angelo.ll.goBle;

import android.content.Context;
import android.os.Bundle;
import android.content.Intent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.TabHost;
import android.view.Window;
import android.view.WindowManager;
import android.os.Message;
import android.app.AlertDialog;
import android.view.View.OnTouchListener;
import android.view.MotionEvent;
import android.widget.TableLayout;
import android.widget.RelativeLayout;
import android.widget.TableLayout.LayoutParams;
import android.util.DisplayMetrics;
import android.os.SystemClock;
import android.os.PowerManager;

public class MainActivity  extends BlunoLibrary implements OnTouchListener{
	private final  static boolean BUTTON_PRESSED=true;
	private final  static boolean BUTTON_RELEASE=false;
	private final  static boolean MODE_TRIGGER=true;
	private final  static boolean MODE_CYCLE=false;
	
	
	
	private Button buttonMode;
	private Button buttonScan;
	private Button buttonHelp;
	private Button button1;
	private Button button2;
	private Button button3;
	private Button button4;
	private Button button5;
	private Button button6;
	
	
	public int bottonNum;
	public int joystickPosition;
	public int joystickValueX;
	public int joystickValueY;
	public boolean[] buttonState;
	
	private boolean sendMode=MODE_TRIGGER;
	private boolean cycleModeSendFlag;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		//requestWindowFeature(Window.FEATURE_NO_TITLE);//隐藏标题
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
							 WindowManager.LayoutParams.FLAG_FULLSCREEN);//设置全屏
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);//屏幕长亮
		
		setContentView(R.layout.activity_main);
		RelativeLayout relativeLayout = (RelativeLayout)findViewById(R.id.joystickRelativeLayout);
		
		DisplayMetrics metrics=new DisplayMetrics();
		getWindowManager().getDefaultDisplay().getMetrics(metrics);
		
		buttonState=new boolean[6];
		
		int viewH=metrics.heightPixels/2;
		int viewW=metrics.widthPixels/3;
        RelativeLayout.LayoutParams lp1 = new RelativeLayout.LayoutParams(viewW, viewH);
      	lp1.addRule(RelativeLayout.ALIGN_PARENT_LEFT|RelativeLayout.CENTER_HORIZONTAL);
	
        YkView yk_view = new YkView(this,this,viewW,viewH);
		relativeLayout.addView(yk_view,lp1);
		
        onCreateProcess();														//onCreate Process by BlunoLibrary
        serialBegin(115200);	//set the Uart Baudrate on BLE chip to 115200

        button1=(Button)findViewById(R.id.button1);
		button2=(Button)findViewById(R.id.button2);
		button3=(Button)findViewById(R.id.button3);
		button4=(Button)findViewById(R.id.button4);
		button5=(Button)findViewById(R.id.button5);
		button6=(Button)findViewById(R.id.button6);
		
		button1.setId(1);//设置按钮id
		button2.setId(2);
		button3.setId(3);
		button4.setId(4);
		button5.setId(5);
		button6.setId(6);
		
		button1.setOnTouchListener(this);//设置触摸操作监听
		button2.setOnTouchListener(this);
		button3.setOnTouchListener(this);
		button4.setOnTouchListener(this);
		button5.setOnTouchListener(this);
		button6.setOnTouchListener(this);
		
		new Thread(new ThreadShow()).start();
		
		buttonMode =(Button)findViewById(R.id.buttonMode);
		buttonMode.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View p1)
				{
					// TODO: Implement this method
					if(sendMode==MODE_TRIGGER)
					{
						sendMode=MODE_CYCLE;
						buttonMode.setText("cycle");
					}
					else if(sendMode==MODE_CYCLE)
					{
						sendMode=MODE_TRIGGER;
						buttonMode.setText("trigger");
					}
				}
			});
		
		buttonHelp = (Button)findViewById(R.id.buttonHelp);
		buttonHelp.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View p1)
				{
					// TODO: Implement this method
					new AlertDialog.Builder(MainActivity.this).setMessage("help\n\n适用于DFRobot出品的bluno系列产品,兼容goBle协议库\nwww.DFRobot.com.cn\n\n模式说明:\ntrigger:发生触摸操作时发送数据\ncycle:0.3s自动发送一次数据\n\n协议规则:\n前三字节固定(55 aa 11)，第四字节为按钮按下个数(00-06)，第五字节为摇杆动作标志(00-03,x轴有动作则为01,y轴动作为02,双轴均动作为03)，第6-n为按钮编号(根据按钮按下个数定字节数，每字节表示一个按钮编号,若为0则无此字节),接下来两字节分别表示摇杆x与y方向坐标(原点左下角，0-255)，接下来两字节留空为0,最后一字节为校验位(前面所有字节和与0xff取余)\n\n2017.2 by LL\n").show();							//Alert Dialog for selecting the BLE device
					
				}
			});
		
        buttonScan = (Button) findViewById(R.id.buttonScan);					//initial the button for scanning the BLE device
        buttonScan.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub

				buttonScanOnClickProcess();										//Alert Dialog for selecting the BLE device
			}
		});
	
}
// 线程类  用于循环模式中定时发送数据
	class ThreadShow implements Runnable {

		@Override
		public void run() {
			// TODO Auto-generated method stub
			while (true) {
				try {
					Thread.sleep(300);
				
					System.out.println("send...");
					if(sendMode==MODE_CYCLE)
					{
						cycleModeSendFlag=true;
						SendPacktBLE();
						cycleModeSendFlag=false;
					}
					
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.out.println("thread error...");
				}
			}
		}
	}

	@Override
	public boolean onTouch(View vw, MotionEvent event)
	{
		
		switch(event.getAction())
		{
			case MotionEvent.ACTION_DOWN://按钮按下
			
				bottonNum++;
				buttonState[vw.getId()-1]=BUTTON_PRESSED;
				SendPacktBLE();
				break;
			case MotionEvent.ACTION_UP://按钮松开
				
				bottonNum--;
				buttonState[vw.getId()-1]=BUTTON_RELEASE;
				SendPacktBLE();
				break;
			default:
			break;
		}
	
		// TODO: Implement this method
		return false;
	}
	
	protected void onResume(){
		super.onResume();
		
		System.out.println("BlUNOActivity onResume");
		onResumeProcess();														//onResume Process by BlunoLibrary
	}
	
	
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		onActivityResultProcess(requestCode, resultCode, data);					//onActivityResult Process by BlunoLibrary
		super.onActivityResult(requestCode, resultCode, data);
	}
	
    @Override
    protected void onPause() {
        super.onPause();
	
        onPauseProcess();														//onPause Process by BlunoLibrary
    }
	
	protected void onStop() {
		super.onStop();
		onStopProcess();														//onStop Process by BlunoLibrary
	}
    
	@Override
    protected void onDestroy() {
        super.onDestroy();	
        onDestroyProcess();														//onDestroy Process by BlunoLibrary
    }

	@Override
	public void onConectionStateChange(connectionStateEnum theConnectionState) {//Once connection state changes, this function will be called
		switch (theConnectionState) {											//Four connection state
		case isConnected:
			buttonScan.setText("Connected");
			break;
		case isConnecting:
			buttonScan.setText("Connecting");
			break;
		case isToScan:
			buttonScan.setText("Scan");
			break;
		case isScanning:
			buttonScan.setText("Scanning");
			break;
		case isDisconnecting:
			buttonScan.setText("isDisconnecting");
			break;
		default:
			break;
		}
	}

	@Override
	public void onSerialReceived(String theString) {							//Once connection data received, this function will be called
		// TODO Auto-generated method stub
	//	serialReceivedText.append(theString);							//append the text into the EditText
		//The Serial data from the BLUNO may be sub-packaged, so using a buffer to hold the String is a good choice.
		//((ScrollView)serialReceivedText.getParent()).fullScroll(View.FOCUS_DOWN);
	}

	//数据协议打包发送
	//协议规则: 前三字节固定55 aa 11，第四字节为按钮按下个数，第五字节为摇杆动作标志(00-03)，第6-n为按钮编号(根据按钮按下个数定字节数，若为0则无此字节),接下来两字节表示摇杆x与y方向坐标(原点左下角，0-255)，接下来两字节留空为0,最后一字节为校验位(前面所有字节和与0xff取余)
	public void SendPacktBLE()
	{
		if((sendMode==MODE_CYCLE)&&(!cycleModeSendFlag))
		{
			return;
		}
		
		
		byte[] packt=new byte[10+bottonNum];//至少10字节+按钮按下的个球
		
		try{
			
		packt[0]=0x55;
		packt[1]=(byte)0xaa;
		packt[2]=0x11;
		packt[3]=(byte)bottonNum;
		packt[4]=(byte)joystickPosition;
		if(bottonNum>0)
		{
			for(int i=0,j=0;i<6;i++)
			{
				if(buttonState[i]) 
				{
					packt[5+j]=(byte)(i+1);
					j++;
				}
			}
		 }
			if(joystickValueX==0x7f)  joystickValueX=0x80;//0x7f无法发送，转换为0x80发送
			if(joystickValueY==0x7f)  joystickValueY=0x80;
			
			packt[5+bottonNum]=(byte)joystickValueX;
			packt[6+bottonNum]=(byte)joystickValueY;
			packt[7+bottonNum]=0;
			packt[8+bottonNum]=0;
			long temp=0;
			for(int ii=0;ii<packt.length;ii++)
			{
				temp=temp+packt[ii];
			}
			packt[9+bottonNum]=(byte)(temp%0xff);
			
			serialSend(packt);
			
			packt=null;
			
		}catch(Exception err){
			new AlertDialog.Builder(MainActivity.this).setMessage(err.toString()).show();							//Alert Dialog for selecting the BLE device
			
			}
	}
	
}
